VERSION 5.00
Begin VB.Form frmDeleteAllScriptsFromOneMailbox 
   Caption         =   "Office Calendar Administration"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   435
   ClientWidth     =   7260
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6270
   ScaleWidth      =   7260
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox cboMailbox 
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   2040
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   300
      Width           =   5115
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Close"
      Height          =   495
      Left            =   180
      TabIndex        =   1
      Top             =   5640
      Width           =   1335
   End
   Begin VB.CommandButton cmdFinish 
      Caption         =   "Finish"
      Height          =   495
      Left            =   2060
      TabIndex        =   2
      Top             =   5640
      Width           =   1335
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   495
      Left            =   3940
      TabIndex        =   3
      Top             =   5640
      Width           =   1335
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5820
      TabIndex        =   4
      Top             =   5640
      Width           =   1335
   End
   Begin VB.Label lblMailbox 
      Caption         =   "Mailbox Name:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Top             =   300
      Width           =   1755
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "Delete All Scripts For The Mailbox Specified Above"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1155
      Left            =   480
      TabIndex        =   5
      Top             =   2820
      Width           =   6375
   End
End
Attribute VB_Name = "frmDeleteAllScriptsFromOneMailbox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

Private Sub cmdBack_Click()

    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Dim varReturn As Variant
    
    varReturn = MsgBox("You have not completed the administrative action. Do you want to shut down?", vbYesNo, "Action Not Completed!")
    
    ' User chose "Yes"
    If varReturn = 6 Then
    
        Unload Me
        
    Else
    
        ' Do Nothing
        
    End If
        
End Sub

Private Sub cmdFinish_Click()

    ' Delete all scripts for the selected mailbox.
        
    Dim varReturn As Variant
    
    On Error GoTo HandleErr
        
    ' Make sure the user chooses a Mailbox from the list.
    If Me.cboMailbox = vbNullString Then
        MsgBox "You must choose a Mailbox from the list", vbCritical, "Choose Mailbox"
        GoTo ExitHere
    End If
        
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    ' User chose "Yes"
    If varReturn = 6 Then
    
        Dim objEvent As Object
        Dim objSession As Session
        Dim objBoundField As Object
        Dim objBindings As Object
        Dim objBinding As Object
        Dim objMessage As Message
        Dim objMailBox As InfoStore
        Dim objAddressList As AddressList
        Dim objAddressEntries As AddressEntries
        Dim strUserName As String
        Dim objAddressEntry As AddressEntry
        Dim strMailBox As String
        Dim objInfoStores As InfoStores
        Dim objInfoStore As InfoStore
        Dim objRootFolder As Folder
        Dim objfolders As Folders
        Dim objFolder As Folder
        Dim strPersonalFolder As String
        
        Set objSession = New MAPI.Session
                
        objSession.Logon ProfileName:="Administrator"
                  
        ' Reference the Recipient based on the Mailbox.
        ' Cannot use Sender of message since users can share
        ' calendars and add appointment items to others
        ' calendars.
        Set objMailBox = objSession.GetInfoStore()
        
        ' Reference the Global Address List
        Set objAddressList = objSession.AddressLists.Item("Global Address List")
          
        Set objAddressEntries = objAddressList.AddressEntries
        
        strUserName = Mid(Me.cboMailbox, 11, 99)
        
        Set objAddressEntry = objAddressList.AddressEntries(strUserName)

        strMailBox = Me.cboMailbox
                
        Set objInfoStores = objSession.InfoStores
        Set objInfoStore = objInfoStores.Item(strMailBox)
        Set objRootFolder = objInfoStore.RootFolder
        Set objfolders = objRootFolder.Folders
                                      
        Set objEvent = CreateObject("MSExchange.Events")
        
        ' Current CDO Session
        objEvent.Session = objSession
        
        For Each objFolder In objfolders
                
            ' Get the bindings collection associated with the folder.
            Set objBoundField = objEvent.BoundFolder(objFolder, True)
            
            Set objBindings = objBoundField.Bindings

                ' Delete each script for the folder.
                For Each objBinding In objBindings
                            
                    Set objMessage = objSession.GetMessage(objBinding.EntryID, Null)
                    
                    objMessage.Delete
                        
                Next
                
        Next
    
        objSession.Logoff
        
        MsgBox "All scripts for the Mailbox have been deleted"
        
        Set objMailBox = Nothing
        Set objAddressList = Nothing
        Set objAddressEntries = Nothing
        Set objAddressEntry = Nothing
        Set objInfoStores = Nothing
        Set objInfoStore = Nothing
        Set objRootFolder = Nothing
        Set objfolders = Nothing
        Set objFolder = Nothing
        Set objBoundField = Nothing
        Set objBindings = Nothing
        Set objBinding = Nothing
        Set objMessage = Nothing
        Set objEvent = Nothing
        Set objSession = Nothing
        
    End If
    
    'Unload Me
    
ExitHere:
    Exit Sub
    
HandleErr:
    MsgBox "Error: " & Err.Description & _
     " (" & Err.Number & ")"
    Resume ExitHere
    
End Sub

Private Sub Form_Load()

    Me.cmdBack.Enabled = True
    Me.cmdFinish.Enabled = True
    Me.cmdNext.Enabled = False
    Me.cmdCancel.Enabled = True
    
    Call LoadMailBoxCombo
    
End Sub

Private Sub LoadMailBoxCombo()

    Dim objSession As MAPI.Session
    Dim i As Integer
            
    ' Assume logged into a valid session.
    Set objSession = New MAPI.Session

    ' Change login profile for your office
    objSession.Logon ProfileName:="Administrator"
    
    i = 1
    
    For i = i To objSession.InfoStores.Count
    
        If Left(objSession.InfoStores(i).Name, 7) = "Mailbox" Then
            Me.cboMailbox.AddItem objSession.InfoStores(i).Name
        End If
        
    Next
    
    objSession.Logoff
    
    Set objSession = Nothing

End Sub

Private Sub Form_Resize()

    If Me.WindowState = vbMinimized Then
        Me.Icon = LoadPicture(App.Path & "\" & "Books05.ICO")
    End If
    
End Sub

